require "import"
import "android.app.*"
import "android.os.*"
import "android.widget.*"
import "android.view.*"

activity.setContentView
(
{
  LinearLayout,
  orientation = "vertical",
  layout_width = "fill",
  layout_height = "fill",
  background = "#4488CCFF",
  padding = "20dp",
  {
    EditText,
    id = "输入框",
    layout_width = "match_parent",
    layout_height = "wrap_content",
    hint = "请输入编码",
    textSize = "18sp",
    background = "#FFFFFF",
    padding = "10dp",
    singleLine = true,
  },
  {
    Button,
    layout_width = "120dp",
    layout_height = "wrap_content",
    layout_gravity = "center_horizontal",
    text = "转换",
    textSize = "18sp",
    onClick = function()
      local 输入内容 = 输入框.getText().toString()
      local 转换结果 = 转换编码处理(输入内容)
      结果视图.setText(转换结果 or "无有效编码")
    end
  },
  {
    ScrollView,
    layout_width = "match_parent",
    layout_height = "wrap_content",
    {
      TextView,
      id = "结果视图",
      layout_width = "match_parent",
      layout_height = "wrap_content",
      textSize = "16sp",
      textColor = "#333333",
      padding = "10dp",
      text = "转换结果将显示在此处"
    }
  }
}
)

function 转换编码处理(输入)
  local 结果 = {}
  for 编码 in 输入:gmatch("%S+") do
    local 字符
    local 码点匹配 = 编码:match("^[Uu]%+(%x+)$") or 编码:match("^(%x+)$")
    if 码点匹配 then
      local 码点 = tonumber(码点匹配, 16)
      if 码点 and 码点 <= 0x10FFFF then
        字符 = utf8.char(码点)
      end
    else
      local hexStr = 编码:gsub("^0[xX]", "")
      if #hexStr%2 == 0 and hexStr:match("^%x+$") then
        local 字节表 = {}
        for i = 1, #hexStr, 2 do
          table.insert(字节表, tonumber(hexStr:sub(i, i+1), 16))
        end
        字符 = string.char(unpack(字节表))
      end
    end
    if 字符 and utf8.len(字符) == 1 then
      table.insert(结果, 字符)
    end
  end
  return #结果 > 0 and table.concat(结果) or nil
end